Attribute VB_Name = "TOOLS"
'History
' 16/08/00      Y.M. Added PlaySound

Option Explicit

Dim Rstring As String * 1024
Global Manquants As String
Global GereManque As Boolean
Global DureeMsg As Integer
Global NivTrace As Integer
Global FicTrace As String
Global F_INI As String
Global INIFILE As String
Public Const HFILE_ERROR = -1
Dim s As String
Dim Chronos(10) As Long
Global Pass As Boolean

      Private Type LUID
         UsedPart As Long
         IgnoredForNowHigh32BitPart As Long
      End Type

      Private Type TOKEN_PRIVILEGES
         PrivilegeCount As Long
         TheLuid As LUID
         Attributes As Long
      End Type


      Private Const EWX_SHUTDOWN As Long = 1
      Private Const EWX_FORCE As Long = 4
      Private Const EWX_REBOOT = 2

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function ExitWindowsEx Lib "user32" ( _
         ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Declare Function GetHandleInformation Lib "kernel32" (ByVal hObject As Long, lpdwFlags As Long) As Boolean
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function GetActiveWindow Lib "kernel32" () As Integer
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal SName As String, KName As Any, SString As Any, ByVal FName As String) As Integer
Declare Function GetProfileString Lib "kernel32" (ByVal lpAppName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer) As Integer
Declare Function lopen Lib "kernel32" Alias "_lopen" (ByVal lpPathName As String, ByVal iReadWrite As Long) As Long
Declare Function lread Lib "kernel32" Alias "_lread" (ByVal hFile As Long, lpBuffer As Any, ByVal wBytes As Long) As Long
Declare Function lclose Lib "kernel32" Alias "_lclose" (ByVal hFile As Long) As Long
Declare Function hread Lib "kernel32" Alias "_hread" (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long
Declare Function LocalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal wBytes As Long) As Long
Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GetProcessVersion Lib "kernel32" (ByVal hModule As Long) As Long
Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Single) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParams As Long, ByVal lParam As Long) As Long
Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetCurrentProcess Lib "kernel32" () As Long
Declare Function OpenProcessToken Lib "advapi32" ( _
         ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, _
         TokenHandle As Long) As Long
Declare Function LookupPrivilegeValue Lib "advapi32" _
         Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, _
         ByVal lpName As String, lpLuid As LUID) As Long
Declare Function AdjustTokenPrivileges Lib "advapi32" ( _
         ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, _
         NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, _
         PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Const SND_ASYNC = &H1         '  play asynchronously

Type RingBuffer
    B As String * 32000
    Nb As Long
    Wp As Long
    Rp As Long
End Type

' Added 21/10/2006 Da Silva Serge
Type PROCESS_INFORMATION
    hProcess            As Long
    hThread             As Long
    dwProcessID         As Long
    dwThreadID          As Long
End Type


' ShellAndWait
Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Sub ForceLignes(Fichier As String, MaxLignes As Integer, NbLignes As Integer)
' Si plus de MaxLignes, ne garde que les Nblignes dernires lignes du fichier texte
Dim Fs As Integer
Dim Fo As Integer
Dim L As String
Dim i As Integer
Dim Temp As String

    If Not FileExists(Fichier) Then Exit Sub
    If MaxLignes <= NbLignes Then MaxLignes = NbLignes * 2
    Fs = FreeFile
    Open Fichier For Input As Fs
    Do While Not EOF(Fs)
        Line Input #Fs, L
        i = i + 1   'Compte les lignes
    Loop
    If i > MaxLignes Then
        Seek #Fs, 1 'Rewind
        i = i - NbLignes    'Nombre de lignes  supprimer
        For NbLignes = 1 To i
            Line Input #Fs, L
        Next NbLignes
        Fo = FreeFile
        Temp = App.Path & "\" & Format(Now, "ddhhmmss") & "." & Format(Fo, "000")
        Open Temp For Output As Fo
        Do While Not EOF(Fs)
            Line Input #Fs, L
            Print #Fo, L
        Loop
        Close Fs
        Close Fo
        Kill Fichier
        Name Temp As Fichier
    Else
        Close Fs
    End If
End Sub

Function WriteRb(RB As RingBuffer, C As String) As Long
' Ecrit un caractre dans buffer.
' Retourne le nombre de caractres en attente ou 0 si buffer plein
    With RB
    If .Nb < 32000 Then
        .Nb = .Nb + 1
        If .Wp > 32000 Then .Wp = 0
        .Wp = .Wp + 1
        Mid(.B, .Wp, 1) = C
        WriteRb = .Nb
    End If
    End With
End Function

Function ReadRb(RB As RingBuffer, N As Integer) As String
'Retourne les N caractres suivants du buffer
Dim NN As Integer
    With RB
    If N > .Nb Then N = .Nb
    If .Nb Then
        .Nb = .Nb - N
        If .Rp + N > 32000 Then     'On va wrapper avant
            NN = 32000 - .Rp
            ReadRb = Mid(.B, .Rp, NN)
            .Rp = 1
        End If
        N = N - NN
        ReadRb = ReadRb & Mid(.B, .Rp, N)
        .Rp = .Rp + N
    End If
    End With
End Function

Function ShowRb(RB As RingBuffer, N As Integer) As String
'Montre les N caractres suivants du buffer sans les retirer
Dim Tp As Long  'Pointeur temporaire
    With RB
    If N > .Nb Then N = .Nb
    If .Nb Then
        Tp = .Rp
        Do While N > 0
            If Tp > 32000 Then Tp = 0
            Tp = Tp + 1
            ShowRb = ShowRb & Mid(.B, Tp, 1)
            N = N - 1
        Loop
    End If
    End With
End Function

Sub ClearRb(RB As RingBuffer)
'Rinitialse le buffer
    With RB
    .Nb = 0
    .Wp = 1
    .Rp = 1
    End With
End Sub

Sub OpenSection(section As String)
    s = "[" & UCase(Trim$(section)) & "]" & Chr$(13) & Chr$(10)
End Sub

Sub AddKey(key As String, Value As String)
    s = s & Trim$(key) & "=" & Trim$(Value) & Chr$(13) & Chr$(10)
End Sub

Sub CloseSection(FicNum As Integer)
    Print #FicNum, s
End Sub

Function GetFname(FullPath As String) As String
'Retourne le nom du fichier sans le chemin
Dim i As Integer
Dim j As Integer
Dim Sep As String
    Sep = "\"   'Assume Windows style
    If InStr(FullPath, "/") Then Sep = "/" 'Set Unix style
    Do
        j = InStr(i + 1, FullPath, Sep)
        If j = 0 Then Exit Do
        i = j
    Loop
    GetFname = Right$(FullPath, Len(FullPath) - i)
End Function

Function GetParams(section As String, Cle As String) As String
Dim s As String
Dim Substitute As String

    s = GetIniString(F_INI, section, Cle)
    If Len(s) Then
        GetParams = s
        Substitute = GetIniString(F_INI, "DEFINE", s)
        If Len(Substitute) Then GetParams = Substitute
    Else
        GetParams = GetIniString(F_INI, "DEFAUT", Cle)
    End If
End Function

Function Get_Start_Params() As String
Dim s As String
Dim P As String
    
    s = LCase$(Command$)
    If Len(s) = 0 Then s = InputBox$("Entrer les parametres", "Pas de parametres")
    If Len(s) = 0 Then
        End
    End If
    INIFILE = Substring(s, 1, " ")
    P = GetPath(INIFILE)
    If InStr(P, ".") = 1 Then INIFILE = App.Path & Mid$(INIFILE, 2)
    If Len(P) = 0 Then INIFILE = App.Path & "\" & INIFILE
    Get_Start_Params = s
End Function
Function GetColor(Objet, Old As Single) As Single
            
    GetColor = Old
    Objet.CancelError = True
    On Error GoTo ColorError
    Objet.ShowColor
    GetColor = Objet.Color
ColorError:
End Function

Sub Set_StartParams()
Dim s As String

    s = Command$
    If Len(s) Then
        INIFILE = Substring(s, 1, " ")
        Exit Sub    'utilise 1er paramtre ligne commande
    End If
    INIFILE = App.Path & "\" & App.EXEName & ".INI" 'utilise fichier par dfaut
End Sub

Function GetIniString(Fichier As String, section As String, Cle As String) As String
Dim s As String
Dim X As Integer
    
    If Not FileExists(Fichier) Then Exit Function
    X = GetPrivateProfileString(ByVal section, ByVal Cle, ByVal "", ByVal Rstring, ByVal Len(Rstring), ByVal Fichier)
    s = Left$(Rstring, X)
    If InStr(s, "'") = 1 Then s = Right$(s, Len(s) - 1)
    GetIniString = s
End Function

Function GetSystemString(SName As String, section As String, Cle As String) As String
Dim Rstring As String
Dim X As Integer
    
    Rstring = String$(256, 0)
    X = GetPrivateProfileString(ByVal section, ByVal Cle, ByVal "", ByVal Rstring, ByVal Len(Rstring), ByVal SName)
    GetSystemString = Left$(Rstring, X)
End Function

Sub SetTrace()
    
    NivTrace = 0
    FicTrace = GetIniString(INIFILE, "DEBUG", "Trace")
    If Len(FicTrace) Then
        If GetPath(FicTrace) = "." Or Len(GetPath(FicTrace)) = 0 Then
            FicTrace = App.Path & "\" & GetFname(FicTrace)
        End If
        NivTrace = Val(GetIniString(INIFILE, "DEBUG", "Niveau"))
    End If
End Sub

Function GetPath(FullPath As String) As String
'Retourne le chemin sans le nom du fichier
Dim i As Integer
Dim j As Integer
Dim Sep As String
    
    GetPath = ""
    If Len(FullPath) Then
        If InStr(FullPath, "/") Then
            Sep = "/" 'Set Unix style
        ElseIf InStr(FullPath, "\") Then
            Sep = "\"   'May be Windows style
        Else
            Exit Function   'None, nothing to return
        End If
        Do
            j = InStr(i + 1, FullPath, Sep)
            If j = 0 Then Exit Do
            i = j
        Loop
        GetPath = Left$(FullPath, i - 1)
    End If
End Function

Function GetExtension(Fichier As String) As String
'Retourne l'extension de fichier (sans le point !)

    GetExtension = Substring(GetFname(Fichier), 2, ".")
End Function

Function Substring(Texte As String, Item As Integer, Separateur As String) As String
Dim D As Integer
Dim f As Integer
Dim i As Integer

    D = 1
    i = 1
    Do
        f = InStr(D, Texte, Separateur)
        If f = 0 Then f = Len(Texte) + 1
        If i = Item Then Exit Do
        i = i + 1
        D = f + Len(Separateur)
        If D > Len(Texte) Then
            Substring = ""
            Exit Function
        End If
    Loop
    Substring = Mid$(Texte, D, f - D)
'    If Len(Substring) = 0 Then Substring = " "
End Function

Function SubStringVal(Texte As String, Item As Integer, Separateur As String) As Integer
    
    SubStringVal = Val(Substring(Texte, Item, Separateur))
End Function

Sub Trace(Niveau As Integer, Message As String)
Dim i As Integer
Dim f As Integer
Dim C As String
Dim s As String

    If (Niveau And NivTrace) = 0 Then Exit Sub
    Do While Niveau
        Niveau = Niveau \ 2
        Message = " " & Message
    Loop
    s = Format(Now, "dd/mm/yyyy hh:mm:ss") & " " & Message
    f = FreeFile
    On Error Resume Next
    Open FicTrace For Append As f
    If Err Then Exit Sub
    Print #f, s
    Close #f
End Sub

Sub WriteIniString(Fichier As String, section As String, Cle As String, Texte As String)
Dim X As Integer

'    Debug.Print Texte
    X = WritePrivateProfileString(ByVal section, ByVal Cle, ByVal Texte, ByVal Fichier)
End Sub

Function FileCopyDiff(Source As String, Destin As String) As Boolean
'Copie source dans destination seulement si contenus differents
Dim Fs As Integer
Dim FD As Integer

    If Not FileExists(Source) Then Exit Function
    If FileExists(Destin) Then
        If FileLen(Destin) <> FileLen(Source) Then
            Copy Source, Destin, 1, True
            FileCopyDiff = True
        Else
            Fs = FreeFile
            Open Source For Input As Fs
            FD = FreeFile
            Open Destin For Input As FD
            If Input(LOF(Fs), Fs) <> Input(LOF(FD), FD) Then
                Close Fs
                Close FD
                Copy Source, Destin, 1, True
                FileCopyDiff = True
            Else
                Close Fs
                Close FD
            End If
        End If
    Else
        Copy Source, Destin, 1, True
        FileCopyDiff = True
    End If
End Function

Sub MarkActivity(MarkFile As String)
Dim f As Integer
    
    f = FreeFile
    Open MarkFile For Output As f
    Print #f, Format(Now, "ddmmyyyyhhmmss")
    Close f
End Sub

Function PathExists(ThisPath As String) As Boolean
Dim Temp As String
    
    PathExists = True
    Temp = CurDir
    On Error Resume Next
    ChDir ThisPath
    If Err Then
        PathExists = False
    End If
    On Error GoTo 0
    ChDir Temp
End Function

Function GetFileListe(Masque) As String
'Retourne la liste de tous les fichiers correspondants au masque sous
' la forme de chaines spares par des virgules.
Dim s As String

    On Error Resume Next
    s = Dir$(Masque, vbHidden + vbSystem + vbReadOnly)
    Do While Len(s)
        GetFileListe = GetFileListe & s & ","
        s = Dir$
    Loop
End Function

Function GetDirListe(Masque As String) As String
'Retourne la liste de tous les sous rpertoires correspondant au masque
' sous la forme de chaines spares par des virgules.
Dim s As String
    
    s = Dir$(Masque, vbDirectory + vbHidden + vbSystem + vbReadOnly)
    Do While Len(s)
        If PathExists(Masque & s) Then GetDirListe = GetDirListe & s & ","
        s = Dir$
    Loop
'    #If Win32 Then
    If Len(Masque) > 3 Then '
    GetDirListe = Mid$(GetDirListe, 6)  'Enlve '.' et '..'
'    #End If
    End If
End Function

Function IsTimeValid(T As String) As Boolean
            
    IsTimeValid = False
    If IsDate(T) Then
        T = Format$(CDate(T), "hh:mm")
        IsTimeValid = True
    End If
End Function

Function ReplaceString(Source As String, Match As String, Replace As String, NoWhite As Boolean) As Integer
    'Remplace dans la chaine source les occurences de 'Match' par 'Replace' et retourne
    ' le nombre de remplacements effectus.
    'Si le flag NoWhite est spcifi, les codes contrles ( < 31 dcimal) sont
    'limins de la chaine de sortie AVANT l'insertion de 'Replace'.
    ' Ex: X  = ReplaceString(S, Chr$(10), Chr$(10), True) retourne le nombre de lignes
    ' non vides de S, et remplace les cr/lf par lf.
    
Dim i As Integer
Dim j As Integer
Dim s As String
Dim T As String
    
    j = 1
'    Debug.Print Source
'    Debug.Print "-------------------"
    s = Substring(Source, j, Match)
    Do While Len(s)
        If NoWhite Then
            s = TTrim(s)
            If Len(s) Then
                T = T & s & Replace
                i = i + 1
            End If
        Else
            T = T & s & Replace
            i = i + 1
        End If
        j = j + 1
        s = Substring(Source, j, Match)
    Loop
    ReplaceString = i
    Source = T
'    Debug.Print Source
End Function

Function TTrim(s As String) As String
'Total Trim: Elimine tous les caractres non imprimables ( 0  32 dcimal)
'Conserve les espaces entre les mots
    
Dim i As Integer
Dim C As String

    s = Trim$(s)    'Supprime espaces de dbut et de fin
    For i = 1 To Len(s)
        C = Mid$(s, i, 1)
        If C > Chr$(31) Then TTrim = TTrim & C
    Next i
End Function

Sub ShowError(ErrDescription As String, Message As String)
'    MsgBox "(" & ErrDescription & ")" & vbCrLf & Message
    MsgBox ErrDescription, , Message
End Sub

Function IsSameFile(F1 As String, F2 As String) As Boolean
'Compare nom et date de deux fichiers avec chemins
'** Rajouter comparaison de la taille ?

    IsSameFile = False
    If FileExists(F1) And FileExists(F2) Then
        If GetFname(F1) = GetFname(F2) And FileDateTime(F1) = FileDateTime(F2) Then
            IsSameFile = True
        End If
    End If
End Function

Function GetNextInList(List As String, Sep As String) As String
' Retourne la sous chaine suivante de la liste de chaines 'List' spares par 'Sep'
' Rinitialis si appel avec un nom de liste diffrent ou de longueur nulle
' Retourne une chaine vide quand liste puise
' Non rentrant !!!

Static i As Integer
Static LastList As String

    If List <> LastList Then
        LastList = List
        i = 0
    End If
    i = i + 1
    GetNextInList = Substring(List, i, Sep)
End Function

Sub MakeDirTree(Tree As String)
' format de Tree: "x:\a\b\c.." ou ".\a\b\c.." ou "a\b\c.." ou "\a\b\c.."
' Cre tout l'arbre avec les sous rpertoires i.e. md a, md a\b, md a\b\c, etc...
Dim i As Integer
Dim s As String
Dim T As String

    i = 1
    s = Substring(Tree, i, "\")
    If InStr(s, ":") Or InStr(s, ".") Or _
        (Len(s) = 0 And Len(Tree) > 0) Then  'Rcupre le premier chemin complet: "x:\a"
        i = i + 1
        s = s & "\" & Substring(Tree, i, "\")
    End If
    T = s
    On Error Resume Next
    Do While Len(T)
        MkDir s
        If Err = 0 Or Err = 75 Then 'Reussi ou dja cr
            i = i + 1
            T = Substring(Tree, i, "\")
            s = s & "\" & T
            Err.Clear
        Else
            MsgBox "MakeDirTree " & Tree & " " & s & vbCrLf & _
                "Erreur " & Err, vbCritical, App.EXEName
        End If
    Loop
'    On Error GoTo 0
End Sub

Function GetKeysInSection(Fichier As String, section As String) As String
'Retourne la liste des cls trouves dans la section spcifie.
' Ignore les entres commenant par ';'

Dim f As Integer
Dim Ligne As String
Dim InSection As Boolean

    If FileExists(Fichier) Then
        f = FreeFile
        Open Fichier For Input As f
        Do While Not EOF(f)
            Line Input #f, Ligne
            If InSection Then
                If InStr(Trim(Ligne), "[") = 1 Then
                    Close f
                    Exit Function
                End If
'                S = UCase(Trim$(Substring(Ligne, 1, "=")))
                s = Trim$(Substring(Ligne, 1, "="))
                If Len(s) And InStr(s, ";") = 0 Then GetKeysInSection = GetKeysInSection & s & ","
            Else
                If InStr(Ligne, "[" & UCase(section) & "]") = 1 Then
                    InSection = True
               End If
            End If
        Loop
        Close f
    End If
End Function

Function GetSections(Fichier As String) As String
'Retourne la liste des sections trouves dans le fichier spcifi
' Ignore les entres commeant par ';'

Dim f As Integer
Dim Ligne As String

    f = IsOpen(Fichier, "Input", 1000)
    If f Then
        Do While Not EOF(f)
            Line Input #f, Ligne
            If InStr(Trim(Ligne), "[") = 1 Then
                Ligne = Mid$(Ligne, 2, InStr(Ligne, "]") - 2)
                GetSections = GetSections & Ligne & ","
            End If
        Loop
        Close f
    End If
End Function

Sub Wait(ByVal Millisecs As Double)
' Ne retourne qu'aprs 'Millisecs' en millisecondes ou si Unsign(GetTickCount) wrappe (le 49 me jour)
Dim Day49 As Double
Dim M As Double

    Day49 = Unsign(GetTickCount)
    M = Day49 + Millisecs   'Unsign(GetTickCount) + Millisecs
    Do
        DoEvents
    Loop While Unsign(GetTickCount) < M Or Unsign(GetTickCount) < Day49 ' bug du 49 me jour, tant pis !
End Sub
Function WaitFor(Something As Boolean, Delai As Long) As Boolean
' Wait for 'something' be true while 'Delai' milliseconds'
' Returns the value of 'Something' as soon it becomes true or
' False if Delai elapsed

Dim Day49 As Double
Dim D As Double   'Ne pas modifier le parametre !

    Day49 = Unsign(GetTickCount)
    D = Day49 + Delai   'Unsign(GetTickCount) + Millisecs
    Do
        DoEvents
        If Something Then
            WaitFor = Something
            Exit Function
        End If
    Loop While Unsign(GetTickCount) < D Or Unsign(GetTickCount) < Day49 ' bug du 49 me jour, tant pis !
End Function

Sub ShowMsg(Message As String, Titre As String)
' Affiche une boite de message pendant 'Duree' x millisecondes
    
    Trace 128, Titre & Chr$(9) & Message
#If ShowMsg Then
    If MyMsg.Visible Or DureeMsg = 0 Then Exit Sub
    MyMsg.LblDelai.Caption = str$(DureeMsg)
    MyMsg.Caption = Titre
    MyMsg.LblMsg.Caption = Message
    MyMsg.Show 0
#End If
End Sub

Function Copy(Org As String, Dest As String, Delai As Integer, TouchDate As Boolean) As Boolean
'Recopie Org sous un nouveau nom (duplique)
Dim W As Double
Dim Day49 As Double

    Copy = False
    Day49 = Unsign(GetTickCount)
    W = Day49 + Delai
    On Error Resume Next
    Do
        Err.Clear
        FileCopy Org, Dest
        If Err = 0 Then
            If TouchDate Then Touch Dest, 0
            Copy = True
            Exit Function
        End If
        DoEvents
    Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    ShowMsg "Can't copy " & Org & " in " & Dest, "Copy Error N" & str(Err) & " " & Err.Description
End Function

Function IsOpen(File As String, Mode As String, Delai As Integer) As Integer
' Retourne un numro de fichier si ouverture possible dans les delais, sinon 0

Dim W As Double
Dim Day49 As Double
    
    Day49 = Unsign(GetTickCount)
    W = Day49 + Delai
    On Error Resume Next
    Select Case UCase(Mode)
    Case "INPUT", "READ", "R"
        Do
            If Not FileExists(File) Then Exit Function
            Err.Clear
            IsOpen = FreeFile
            Open File For Input Access Read As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case "OUTPUT", "WRITE", "W"
        Do
            Err.Clear
            IsOpen = FreeFile
            Open File For Output Access Write As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case "APPEND", "A"
        Do
            Err.Clear
            IsOpen = FreeFile
            Open File For Append Access Write As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case "BINARY", "B"
        Do
            Err.Clear
            IsOpen = FreeFile
            Open File For Binary Access Read Write As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case "READBINARY", "RB"
            If Not FileExists(File) Then Exit Function
            Do
            Err.Clear
            IsOpen = FreeFile
            Open File For Binary Access Read As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case "WRITEBINARY", "WB"
        Do
            Err.Clear
            IsOpen = FreeFile
            Open File For Binary Access Write As IsOpen
            If Err = 0 Then Exit Do
            DoEvents
        Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    Case Else
        Mode = "Unknow mode"
        Error 55
    End Select
    If Err Then
        ShowMsg "Can't open " & File & " for " & Mode, "IsOpen Error N" & str(Err) & _
            " " & Err.Description
        IsOpen = 0
    End If
    Err.Clear
End Function

Function Delete(File As String, Delai As Integer) As Boolean
' Dtruit le fichier si possible sinon renvoie 'False'
Dim W As Double
Dim Day49 As Double
    
    Day49 = Unsign(GetTickCount)
    W = Day49 + Delai
    Delete = False
    On Error Resume Next
    Do
        Err.Clear
        Kill File
        If Err = 0 Or Err = 53 Then     'Accepter sans rler si fichier inexistant
            Delete = True
            Exit Function
        End If
        DoEvents
    Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    ShowMsg "Can't delete " & File, "Delete Error N" & str(Err) & _
            " " & Err.Description
End Function
Function DelTree(Path As String) As Boolean
'Vide et dtruit le rpertoire spcifi.
Dim RList As String
Dim Flist As String
Dim R As String
Dim f As String
Dim i As Integer
    
    If Not PathExists(Path) Then Exit Function
    Flist = GetFileListe(Path & "\*.*")  'Obtiend la liste des fichiers
    i = 1
    f = Substring(Flist, i, ",")
    Do While Len(f)
        Delete Path & "\" & f, 1        'Efface tous les fichiers
        i = i + 1
        f = Substring(Flist, i, ",")
    Loop
    RList = GetDirListe(Path & "\")     'Obtiend la liste des sous rpertoires
    i = 1
    R = Substring(RList, i, ",")
    Do While Len(R)                     'pour chaque sous rpertroire
        DelTree Path & "\" & R          'Rcursif
        i = i + 1
        R = Substring(RList, i, ",")
    Loop
    RmDir Path
End Function
Function ExecOnTree(Path As String, Action As Long) As Boolean

    
End Function

Function Rename(OldName As String, NewName As String, Delai As Integer, TouchDate As Boolean) As Boolean
'Renomme le fichier si possible
'Si 'TouchDate', met NewName  la date courante
'Remplace 'NewName' si existe dj
'Si lecteurs diffrents, copie puis dtruit ancien

    If Copy(OldName, NewName, Delai, TouchDate) Then
        Rename = Delete(OldName, 0)
    End If
End Function
Function CheckIfFiles(Liste As String, Path As String, Sep As String) As String
'Retourne 'Liste' sans les fichiers introuvables dans 'Path'
Dim i As Integer
Dim s As String
Dim T As String

    If Len(Liste) Then
        i = 1
        T = Substring(Liste, i, Sep)
        Do While Len(T)
            If FileExists(Path & "\" & T) Then s = s & T & Sep
            i = i + 1
            T = Substring(Liste, i, Sep)
        Loop
        CheckIfFiles = s
    End If
End Function
Function FileExists(File As String) As Boolean
' Indique si le fichier existe
    If Len(File) = 0 Then Exit Function
    On Error Resume Next
    Call FileDateTime(File)
    
    If Err Then
        If GereManque Then Manque File
    Else
        FileExists = True
    End If
End Function

Sub Manque(s As String)
    If Len(Manquants) < 32000 Then
        If InStr(Manquants, s) = 0 Then Manquants = Manquants & s & "," 'Sans dupliquer !
    End If
End Sub

Function Touch(File As String, Delai As Integer) As Boolean
' Change la date du fichier par la date courante
Dim f As Integer
Dim X As String * 1

    Touch = False
    f = IsOpen(File, "Binary", Delai)
    If f Then
        If LOF(f) Then
            Get #f, 1, X
            Put #f, 1, X
            Touch = True
        Else
        ShowMsg "Can't change date if file is empty " & File, "Touch Error N" & str(Err) & _
            " " & Err.Description
        End If
        Close f
    End If
End Function

Function XClose(FileNum As Integer, Delai As Integer) As Boolean
Dim W As Double
Dim Day49 As Double
    
    Day49 = Unsign(GetTickCount)
    W = Day49 + Delai
    XClose = False
    On Error Resume Next
    Do
        Err.Clear
        Close FileNum
        If Err = 0 Then
            XClose = True
            Exit Function
        End If
        DoEvents
    Loop While Unsign(GetTickCount) < W Or Unsign(GetTickCount) < Day49
    ShowMsg "Can't close" & str(FileNum), "Close Error N" & str(Err) & _
            " " & Err.Description
End Function

Function CountFileLines(Fichier As String) As Integer
'Retourne le nombre de lignes non vides de 'Fichier'
'0 si fichier inaccessible
Dim L As String
Dim f As Integer

    f = IsOpen(Fichier, "Input", 1000)
    If f Then
        While Not EOF(f)
            Line Input #f, L
            If Len(L) Then CountFileLines = CountFileLines + 1
        Wend
        XClose f, 1000
    End If
End Function

Function CountStringLines(s As String) As Integer
'Retourne le nombre de lignes non vides de S
' *** (Voir CountStrings dans ce mme module)
End Function

Function TrieListeChaine(Liste As String, Mode As Integer, Sens As Integer) As String
' Retourne la liste trie dans le sens spcifi (1 = Croissant, 0 = Dcroissant)
' selon Mode (1= Texte(Alphabtique), 0 = Binaire)
Dim s As String
Dim S1 As String
Dim S2 As String
Dim i As Integer
Dim j As Integer
Dim T() As String

    i = 1
    s = Trim$(Substring(Liste, i, ","))
    While Len(s)    'On rempli le tableau
        i = i + 1
        ReDim Preserve T(i)
        T(i - 1) = s 'L'indice 0 n'est pas utilis !
        s = Substring(Liste, i, ",")
    Wend
    If i > 2 Then 'Il y a qqchose  trier
        i = i - 1
        j = 1
        While j < i
            If StrComp(T(j + 1), T(j), Mode) = -Sens Then 'Permuter
                S1 = T(j + 1)
                T(j + 1) = T(j)
                T(j) = S1
                If j > 1 Then j = j - 1 'Retester le prcdent
            Else
                j = j + 1
            End If
        Wend
        For j = 1 To i  'Cre la chaine en sortie
            TrieListeChaine = TrieListeChaine & T(j) & ","
        Next j
    Else
    TrieListeChaine = Liste
    End If
End Function

Function TrieTableau(T(), Col As Integer, Mode As Integer) As Integer
' Ordonne les lignes d'un tableau  2 dimension selon le contenu de la colonne spcifie
' Mode = 0: Binaire, 1: Alphabtique, 2: Numrique
' Sens = Toujours croissant
' Retourne <> 0 si anomalie.

Dim L As Integer
Dim C As Integer
Dim i As Integer
Dim j As Integer
Dim Swaped As Boolean

    L = UBound(T, 1)
    C = UBound(T, 2)
    ReDim TT(1, C)
    If L > 1 Then   'S'il y a au moins 2 lignes
        If C >= Col Then    'et si la colonne spcifie existe
            i = 1
            While i < UBound(T, 1)
                Swaped = False
                If Mode = 2 Then
                    If T(i + 1, Col) < T(i, Col) Then
                        Swaped = True
                        For j = 0 To C
                            TT(0, j) = T(i + 1, j) 'Permuter
                            T(i + 1, j) = T(i, j)
                            T(i, j) = TT(0, j)
                        Next
                        If i > 0 Then i = i - 1 'Retester le prcdent
                    End If
                Else
                    If StrComp(T(i + 1, Col), T(i, Col), Mode) = -1 Then
                        Swaped = True
                        For j = 0 To C
                            TT(0, j) = T(i + 1, j) 'Permuter
                            T(i + 1, j) = T(i, j)
                            T(i, j) = TT(0, j)
                        Next
                        If i > 0 Then i = i - 1 'Retester le prcdent
                    End If
                End If
                If Not Swaped Then
                    i = i + 1
                End If
            Wend
         Else
            TrieTableau = -1
        End If
    Else
        TrieTableau = -2
    End If
End Function

Sub StartChrono(Chrono As Integer)
' Lance un chrono
    On Error Resume Next
    Chronos(Chrono) = Unsign(GetTickCount)
End Sub

Sub ShowChrono(Chrono As Integer)
'Affiche un chrono
Dim TT As Long

    On Error Resume Next
    TT = Unsign(GetTickCount)
    MsgBox Format$((TT - Chronos(Chrono)) / 1000, "0.000") & " secondes", 0, "Chrono" & str$(Chrono)
'    ShowMsg Str$(TT - Chronos(Chrono)) & " Millisecondes", "Chrono" & Str$(Chrono)
End Sub

Function UnsignedTovbInteger(ByVal Unsigned As Long) As Integer
'Convertit un long reprsentant entier non sign (retourn par un appel  un API par exemple) en
'entier non sign  passer  une fonction externe

    If (Unsigned And &H8000&) = 0 Then
        UnsignedTovbInteger = Unsigned And &HFFFF&
    Else
        UnsignedTovbInteger = &H8000 Or (Unsigned And &H7FFF&)
    End If
End Function

Function CountStrings(s As String, SubS As String) As Integer
'Retourne le nombre de 'SubS'contenues dans 'S'.
Dim D As Long
Dim f As Long

    D = 1
    Do
        f = InStr(D + 1, s, SubS)
        If f Then CountStrings = CountStrings + 1
        D = f
    Loop While D
End Function
Public Function GetFileSpecs(Objet, DefPath As String, DefFichier As String, Titre As String, Mode As String) As String
' Interface pour CommonDialog 'Ouvrir / Enregistrer sous'
'DefPath ne doit pas inclure le "\" terminal
Dim s As String
Dim E As String
    
    With Objet
    .CancelError = True
    .Filter = "Tous fichiers (*.*)|*.*"
    .FilterIndex = 1
    E = GetExtension(DefFichier)
    If Len(E) Then
        .Filter = .Filter & "|Fichiers " & App.EXEName & " (*." & E & ")|*." & E
        .FilterIndex = 2
    End If
    .Flags = &H804
    .DialogTitle = Titre
    .InitDir = DefPath
    .FileName = DefFichier
    On Error Resume Next
    If Mode Like "Open" Then .ShowOpen
    If Mode Like "Save" Then .ShowSave
    s = .FileName
    If (Len(s) <> 0) And Err = 0 Then
        GetFileSpecs = s
    End If
    End With
End Function

Public Function GetFileDate(Fichier As String) As Date

    GetFileDate = "00:00"
    On Error Resume Next
    GetFileDate = FileDateTime(Fichier)
End Function

Public Function HexDump(s As String, Bloc As Long) As String
' Retourne un dump Hexadcimal de 256 octets de S.

Dim Debut As Integer
Dim Ligne As Integer
Dim Colonne As Integer
Dim C(1 To 16) As String
Dim H As String

    For Ligne = 1 To 16
    H = Hex((16 * (Ligne - 1)) + (256 * Bloc))
    If Len(H) < 8 Then H = String(8 - Len(H), "0") & H
    HexDump = HexDump & H & ": "
        For Colonne = 1 To 16   ' les valeurs hexadciamales
            C(Colonne) = Mid$(s, Debut + 1, 1)
            If Len(C(Colonne)) Then
                H = Hex(Asc(C(Colonne)))
                If Len(H) < 2 Then H = "0" & H
            Else
                H = ".."
            End If
            Debut = Debut + 1
            HexDump = HexDump & H & " "
        Next Colonne
        HexDump = HexDump & "  "
        For Colonne = 1 To 16   'les caractres ascii imprimables
            If C(Colonne) < " " Then C(Colonne) = " "
            HexDump = HexDump & C(Colonne)
        Next Colonne
        HexDump = HexDump & vbCrLf
    Next Ligne
    HexDump = HexDump & vbCrLf
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Public Function Unsign(X As Long) As Double
' Retourne un single reprsentant un entier non sign.
' Utile pour traiter les valeurs retournes par des DLL qui renvoient un ULong
'Dim XX As Double
'    XX = X
'    If XX < 0 Then
'        Unsign = 2147483647 + XX
'        Unsign = Unsign + 2147483648#
'    Else
'        If XX = 0 Then
'            Unsign = XX + 1
'        End If
'        Unsign = XX
'    End If
'End Function
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function Unsign(X As Long) As Long
'Retourne X sans le signe

    Unsign = X And &H7FFFFFFF
End Function


Public Sub CenterForm(f As Form)

    f.Top = (Screen.Height - f.Height) / 2
    f.Left = (Screen.Width - f.Width) / 2
End Sub

Public Function Crc(s As String, Debut As Integer) As String
'Retourne le CRC (Xor) de S
Dim i As Integer
Dim X As Integer

    For i = Debut To Len(s)
        X = X Xor Asc(Mid$(s, i, 1))
    Next i
    Crc = Chr$(X)
End Function
Public Function FormatTexte(s As String, C As Integer, Tableau() As String) As Integer
' Rempli le tableau avec des lignes de longueur 'C' extraites de S et centres
' *** S ne doit pas contenir de caractres de contrle ***
' Retourne le nombre de lignes (Taille du tableau)
Dim Lignes As Integer
Dim Debut As Integer
Dim T As String
Dim U As String
Dim L As Integer

    Debut = 1
    s = Trim$(s)
    T = Substring(s, Debut, " ")
    Do While Len(T)
        T = Trim$(T)
        Do While Len(T) < C                             'Il reste de la place
            U = Trim$(Substring(s, Debut + 1, " "))     'Essaie le suivant
            Debut = Debut + 1
            If Len(U) + Len(T) < C Then                 'C'est bon
                T = T & " " & U
            Else
                Exit Do
            End If
        Loop
        T = Trim$(T)
        L = Len(T)
        If L = C Then Debut = Debut + 1
        L = C - L
        If L > 1 Then                           'Centrer
            L = L \ 2
            T = String(L, " ") & T & String(L, " ")
        End If
        Lignes = Lignes + 1
        ReDim Preserve Tableau(Lignes)
        Tableau(Lignes - 1) = T
        T = Substring(s, Debut, " ")
    Loop
    FormatTexte = Lignes
End Function
Public Sub AdjustToken()

         Const TOKEN_ADJUST_PRIVILEGES = &H20
         Const TOKEN_QUERY = &H8
         Const SE_PRIVILEGE_ENABLED = &H2
         Dim hdlProcessHandle As Long
         Dim hdlTokenHandle As Long
         Dim tmpLuid As LUID
         Dim tkp As TOKEN_PRIVILEGES
         Dim tkpNewButIgnored As TOKEN_PRIVILEGES
         Dim lBufferNeeded As Long

         hdlProcessHandle = GetCurrentProcess()
         OpenProcessToken hdlProcessHandle, (TOKEN_ADJUST_PRIVILEGES Or _
            TOKEN_QUERY), hdlTokenHandle

         ' Get the LUID for shutdown privilege.
         LookupPrivilegeValue "", "SeShutdownPrivilege", tmpLuid

         tkp.PrivilegeCount = 1    ' One privilege to set
         tkp.TheLuid = tmpLuid
         tkp.Attributes = SE_PRIVILEGE_ENABLED

         ' Enable the shutdown privilege in the access token of this
         ' process.
         AdjustTokenPrivileges hdlTokenHandle, False, tkp, _
            Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded

      End Sub

Public Sub SystemRestart()
#If NT Then
    AdjustToken
#End If
   ExitWindowsEx (EWX_SHUTDOWN Or EWX_FORCE Or EWX_REBOOT), &HFFFF
      End Sub
 
Public Sub ShowTrace(T As String, f As Form)
'Montre T dans l'objet texte 'Voir' de la feuille F si elle est visible
    
    If f.WindowState <> 1 Then
        If Len(f.Voir.Text) > 16000 Then   'Void overflow
            f.Voir.Text = ""
        End If
        f.Voir.SelText = T & vbCrLf
    End If
    Trace 1, T
End Sub

Public Sub ClearTrace(f As Form)

    f.Voir.Text = ""
End Sub
Public Sub PlaySound(Wavefile As String)

    If Len(Wavefile) > 0 And FileExists(Wavefile) Then
        sndPlaySound Wavefile, SND_ASYNC
    End If
End Sub
Public Function AdjustText(V As Variant, Lenght As Integer)
'Retourne une chaine de longueur 'Lenght' contenant V et padde avec des espaces
Dim s As String
Dim L As Integer

    s = Format$(V)  'Regle le pb du NULL
    L = Len(s)
    If L < Lenght Then      'Trop court
        AdjustText = s & String$(Lenght - L, " ")
    Else
        AdjustText = Mid$(s, 1, Lenght)     'Trop long
    End If
End Function
Public Function ForceDp(V As String) As String
'Remplace la virgule par le point dans un variant reprsentant un nombre
Dim VPos As Integer

    VPos = InStr(V, ",")
    If VPos Then    'Y'en a
        ForceDp = Substring(V, 1, ",") & "." & Substring(V, 2, ",")
    Else
        ForceDp = V
    End If
End Function

Public Function SpawnObject(Fichier As String) As Long

    If FileExists(Fichier) Then
        SpawnObject = ShellExecute(0, "Open", Fichier, "", App.Path, SW_SHOWNORMAL)
        DoEvents
    End If
End Function

